unit fmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, ExtCtrls, uos_flat, ctypes;

type

  { Tfrmain }

  Tfrmain = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    CheckBox1: TCheckBox;
    PaintBox1: TPaintBox;
    ProgressBar1: TProgressBar;
    ProgressBar10: TProgressBar;
    ProgressBar2: TProgressBar;
    ProgressBar3: TProgressBar;
    ProgressBar4: TProgressBar;
    ProgressBar5: TProgressBar;
    ProgressBar6: TProgressBar;
    ProgressBar7: TProgressBar;
    ProgressBar8: TProgressBar;
    ProgressBar9: TProgressBar;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure updatebuttonplay;
    procedure inputprocess;
    procedure outlevels;
    procedure endrecords;
  private

  public

  end;

  equalizer_band_type=record
    lo_freq,hi_freq:integer;
    text:string[10];
  end;

var
  frmain: Tfrmain;
  thebuffer:array of cfloat;
  thebufferinfos: TuosF_BufferInfos;
  PlayerIndex1: cardinal;
  In1Index, out1index, x : integer;
  Equalizer_Bands:array[1..10] of equalizer_band_type;
  thearray : array of cfloat;

implementation

{$R *.lfm}

{ Tfrmain }
procedure TFrmain.endrecords;
begin

end;

procedure TFrmain.outlevels;
var
  i,v:integer;
begin
  frmain.Caption:=inttostr(uos_InputPosition(PlayerIndex1, In1Index)*2);

  If uos_getstatus(PlayerIndex1) > 0 then
  begin
    i:=1;
    thearray := uos_InputFiltersGetLevelArray(PlayerIndex1,In1Index);
    x := 0;
    while x < length(thearray) -1 do
    begin
      if i<=10 then
      begin

        v:= trunc((thearray[x]+thearray[x+1])*50);

        TProgressBar(findcomponent('ProgressBar'+inttostr(i))).position:=v;
      end;
      x:=x+2;
      inc(i);
    end;
  end;
end;

procedure TFrmain.inputprocess;
var
  i,v,pos:integer;
begin
  pos:=Length(thebuffer);
  pos:=round(pos div paintbox1.Width);
  frmain.Caption:=inttostr(pos);
  If uos_getstatus(PlayerIndex1) > 0 then
  begin
    i:=1;
    thearray := uos_InputFiltersGetLevelArray(PlayerIndex1,In1Index);
    x := 0;
    while x < length(thearray) -1 do
    begin
      if i<=10 then
      begin

        v:= trunc((thearray[x]+thearray[x+1])*50);

        TProgressBar(findcomponent('ProgressBar'+inttostr(i))).position:=v;

        PaintBox1.Canvas.Pen.Width:=15;
        PaintBox1.Canvas.Pen.Color := clgreen;
        PaintBox1.Canvas.Line(pos,paintbox1.height ,pos, paintbox1.height -v);

      end;
      x:=x+2;
      inc(i);
    end;
  end;
 //Application.ProcessMessages;
end;

procedure TFrmain.updatebuttonplay;
var
  i:integer;
begin
  frmain.Button2.Enabled:=true;
  frmain.Button4.Enabled:=false;
  for i:=1 to 10 do
  begin
    TProgressBar(findcomponent('ProgressBar'+inttostr(i))).position:=0;
    application.ProcessMessages;
  end;
  sleep(500);
  application.ProcessMessages;
end;

procedure Tfrmain.Button1Click(Sender: TObject);
var
  i:integer;
begin
  PlayerIndex1 := 0;
  // PlayerIndex : from 0 to what your computer can do ! (depends of ram, cpu, ...)
  // If PlayerIndex exists already, it will be overwritten...

  uos_CreatePlayer(PlayerIndex1);
  //// Create the player.
  //// PlayerIndex : from 0 to what your computer can do !
  //// If PlayerIndex exists already, it will be overwriten...

  SetLength(thebuffer,0);
  uos_AddIntoMemoryBuffer(PlayerIndex1,@thebuffer);
  // Prepare de Buffer

  {$if defined(cpuarm)} // needs lower latency
    out1index := uos_AddIntoDevOut(PlayerIndex1, -1, 0.08, -1, -1, -1, -1) ;
  {$else}
    out1index := uos_AddIntoDevOut(PlayerIndex1);
  {$endif}

  uos_outputsetenable(PlayerIndex1,out1index,checkbox1.checked);

  In1Index := uos_AddFromDevIn(PlayerIndex1);  /// add Input from mic into IN device with default parameters


  uos_InputAddDSPVolume(PlayerIndex1, In1Index, 1, 1);
    ///// DSP Volume changer
    //////////// PlayerIndex : Index of a existing Player
    ////////// In1Index : InputIndex of a existing input
    ////////// VolLeft : Left volume
    ////////// VolRight : Right volume

  uos_InputSetDSPVolume(PlayerIndex1,In1Index,TrackBar1.position/100, TrackBar2.position/100,True); /// Set volume
    /////// procedure to execute when stream is terminated
    //   uos_EndProc(PlayerIndex1, @ClosePlayer1);
    ///// Assign the procedure of object to execute at end
    //////////// PlayerIndex : Index of a existing Player
    //////////// ClosePlayer1 : procedure of object to execute inside the loop

  for i:=1 to 10 do
  begin
    uos_InputAddFilter(PlayerIndex1, In1Index, Equalizer_Bands[i].lo_freq,Equalizer_Bands[i].hi_freq, 1, 3, false, nil);
  end;

  uos_LoopProcIn(PlayerIndex1, In1Index, @inputprocess);
  uos_Play(PlayerIndex1);

  Button1.Enabled:=false;
  Button3.Enabled:=true;
  Application.ProcessMessages;
end;

procedure Tfrmain.Button2Click(Sender: TObject);
var
  i:integer;
begin
  PlayerIndex1 := 0;
  // PlayerIndex : from 0 to what your computer can do ! (depends of ram, cpu, ...)
  // If PlayerIndex exists already, it will be overwritten...

  uos_CreatePlayer(PlayerIndex1);
  //// Create the player.
  //// PlayerIndex : from 0 to what your computer can do !
  //// If PlayerIndex exists already, it will be overwriten...

  uos_CustBufferInfos(thebufferinfos,44100,2,2,Length(thebuffer) div 2);
  In1Index := uos_AddFromMemoryBuffer(PlayerIndex1,thebuffer,thebufferinfos,-1,1024*4);


  {$if defined(cpuarm)} // needs lower latency
    uos_AddIntoDevOut(PlayerIndex1, -1, 0.3, uos_InputGetSampleRate(PlayerIndex1, In1Index),
    uos_InputGetChannels(PlayerIndex1, In1Index), -1, -1, -1);
  {$else}
    uos_AddIntoDevOut(PlayerIndex1, -1, -1, uos_InputGetSampleRate(PlayerIndex1, In1Index),uos_InputGetChannels(PlayerIndex1, In1Index), -1, -1, -1);
  {$endif}

  uos_InputAddDSP1ChanTo2Chan(PlayerIndex1, In1Index);
  uos_InputAddDSPVolume(PlayerIndex1, In1Index, 1, 1);
  uos_InputSetDSPVolume(PlayerIndex1, In1Index, TrackBar1.position/100,TrackBar2.position/100, True); /// Set volume

  uos_InputSetPositionEnable(PlayerIndex1, In1Index, 1);

  for i:=1 to 10 do
  begin
    uos_InputAddFilter(PlayerIndex1, In1Index, Equalizer_Bands[i].lo_freq,Equalizer_Bands[i].hi_freq, 1, 3, false, nil);
  end;

  /////// procedures to execute in events
  uos_LoopProcIn(PlayerIndex1,In1Index,@outlevels);
  uos_EndProc(PlayerIndex1, @updatebuttonplay);


  uos_Play(PlayerIndex1);  /////// everything is ready to play...
  Button2.Enabled:=false;
  Button4.Enabled:=true;
end;

procedure Tfrmain.Button3Click(Sender: TObject);
begin
  uos_Stop(PlayerIndex1);
  frmain.Button1.Enabled:=true;
  Button3.Enabled:=false;
end;

procedure Tfrmain.Button4Click(Sender: TObject);
begin
  uos_Stop(PlayerIndex1);
  Button2.Enabled:=true;
  Button4.Enabled:=false;
end;

procedure Tfrmain.FormActivate(Sender: TObject);
var
  libportaudiopath:pchar;
  {$IFDEF Darwin}
  opath:string;
  {$ENDIF}
begin
  {$IFDEF Windows}
    {$if defined(cpu64)}
      libportaudiopath:=Pchar(application.Location + 'lib\Windows\64bit\LibPortaudio-64.dll');
    {$else}
      libportaudiopath:=Pchar(application.Location + 'lib\Windows\32bit\LibPortaudio-32.dll');
    {$endif}
  {$ENDIF}

  {$IFDEF Darwin}
    opath := application.Location;
    opath := copy(opath, 1, Pos('/uos', opath) - 1);
    liportaudiopath := opath + '/lib/Mac/32bit/LibPortaudio-32.dylib';
  {$ENDIF}


  {$if defined(cpu64) and defined(linux) }
    libportaudiopath :=  application.Location + 'lib/Linux/64bit/LibPortaudio-64.so';
  {$ENDIF}
  {$if defined(cpu86) and defined(linux)}
  libportaudiopatht :=  application.Location + 'lib/Linux/32bit/LibPortaudio-32.so';
  {$ENDIF}
    {$if defined(linux) and defined(cpuarm)}
      libportaudiopath :=  application.Location + 'lib/Linux/arm_raspberrypi/libportaudio-arm.so';
  {$ENDIF}

  {$IFDEF freebsd}
  {$if defined(cpu64)}
    libportaudiopath := application.Location +  'lib/FreeBSD/64bit/libportaudio-64.so';
  {$else}
    libportaudiopath := application.Location +  'lib/FreeBSD/32bit/libportaudio-32.so';
  {$endif}
  {$ENDIF}

  if  uos_LoadLib(libportaudiopath, nil, nil, nil, nil, nil)=0 then
    ShowMessage('PortAudio loaded')
  else
    ShowMessage('Cant load PortAudio!!');
   Equalizer_Bands[1].lo_freq:=18;
   Equalizer_Bands[1].hi_freq:=46;
   Equalizer_Bands[1].Text:='31.25';
   Equalizer_Bands[2].lo_freq:=47;
   Equalizer_Bands[2].hi_freq:=94;
   Equalizer_Bands[2].Text:='62.5';
   Equalizer_Bands[3].lo_freq:=95;
   Equalizer_Bands[3].hi_freq:=188;
   Equalizer_Bands[3].Text:='125';
   Equalizer_Bands[4].lo_freq:=189;
   Equalizer_Bands[4].hi_freq:=375;
   Equalizer_Bands[4].Text:='250';
   Equalizer_Bands[5].lo_freq:=376;
   Equalizer_Bands[5].hi_freq:=750;
   Equalizer_Bands[5].Text:='500';
   Equalizer_Bands[6].lo_freq:=751;
   Equalizer_Bands[6].hi_freq:=1500;
   Equalizer_Bands[6].Text:='1K';
   Equalizer_Bands[7].lo_freq:=1501;
   Equalizer_Bands[7].hi_freq:=3000;
   Equalizer_Bands[7].Text:='2K';
   Equalizer_Bands[8].lo_freq:=3001;
   Equalizer_Bands[8].hi_freq:=6000;
   Equalizer_Bands[8].Text:='4K';
   Equalizer_Bands[9].lo_freq:=6001;
   Equalizer_Bands[9].hi_freq:=12000;
   Equalizer_Bands[9].Text:='8K';
   Equalizer_Bands[10].lo_freq:=12001;
   Equalizer_Bands[10].hi_freq:=20000;
   Equalizer_Bands[10].Text:='16K';
end;

end.

